package com.css.simulation.resource.project.mapper;

import api.common.pojo.param.project.SimulationManualProjectParam;
import api.common.pojo.po.project.SimulationAutomaticSubProjectPo;
import api.common.pojo.vo.project.SimulationManualProjectVo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;

import java.util.List;

@Mapper
@Repository
public interface SimulationAutomaticSubProjectMapper {

     @Select("        select s.id,\n" +
             "               p.scene,\n" +
             "               s.project_id,\n" +
             "               p.project_name,\n" +
             "               p.algorithm,\n" +
             "               p.algorithm_type,\n" +
             "               p.vehicle,\n" +
             "               p.project_describe,\n" +
             "               s.start_time,\n" +
             "               s.finish_time,\n" +
             "               s.now_run_state,\n" +
             "               p.parallelism,\n" +
             "               p.max_simulation_time,\n" +
             "               p.is_choice_gpu,\n" +
             "               s.evaluation_level\n" +
             "        from simulation_automatic_subproject s\n" +
             "                 left join simulation_automatic_project p on s.parent_id = p.id\n" +
             "        where s.id = #{id}")
     SimulationManualProjectVo selectById(@Param("id") String id);

     @Select("        select p.scene\n" +
             "        from simulation_automatic_subproject s\n" +
             "                 left join simulation_automatic_project p on s.parent_id = p.id\n" +
             "        where s.id = #{id}")
     String selectSceneById(@Param("id") String id);

     SimulationAutomaticSubProjectPo selectLastProjectId(String id);

     int addAutomaticSubProject(SimulationAutomaticSubProjectPo po);

     List<SimulationAutomaticSubProjectPo> selectProjectNowRunState(String[] ids);

     int deleteProject(String[] ids);

     List<SimulationManualProjectVo> selectList(SimulationManualProjectParam param);

     SimulationAutomaticSubProjectPo selectById(SimulationManualProjectParam param);

     SimulationManualProjectVo selectProjectInfo(SimulationManualProjectParam param);

     int updateNowRunState(SimulationManualProjectParam param);


}
